!***********************************************************************
!***********************************************************************

program main

	use myproblem
	
	implicit none

	! LOCAL SCALARS
	integer :: m, mquad, mnquad, nfev, ngev, outiter,totiniter, info, i
	real(kind=8) :: stp, stmin, stmax, ftol, gtol
	logical :: iprint
	
	! LOCAL ARRAYS
	real(kind=8) :: stps(4)
	real(kind=8),allocatable :: f0(:), g0(:)
	logical,allocatable :: quadratic(:)
	integer,allocatable :: quadind(:), nquadind(:)
         
	! Set the algorithmic parameters
	ftol   = 1.d-04
	gtol   = 1.d-01
	stmin  = 0.0d0
	stmax  = 1.0d10
	iprint = .true.

	! Call routine inip
	call inip(m,quadratic,stps)
	
	! Define variables mquad and mnquad	
	mquad  = 0
	mnquad = 0 
	do i = 1, m
			if ( quadratic(i) ) then
				mquad = mquad + 1
			else
				mnquad = mnquad + 1     
			end if
	end do
	
	allocate(f0(m),g0(m),quadind(mquad),nquadind(mnquad))	

	! Define variables quadind and nquadind	
	mquad  = 0
	mnquad = 0 
	do i = 1, m
			if ( quadratic(i) ) then
					mquad = mquad + 1
					quadind(mquad) = i
			else
			    mnquad = mnquad + 1     
					nquadind(mnquad) = i        
			end if
	end do
	
	! Compute f0 and g0
	do i = 1,m
		call evalf(0.0d0,f0(i),i)
		call evalg(0.0d0,g0(i),i)
	end do
	
	do i = 1,4
	
		! Set the inital trial step-size
		stp = stps(i)
		
		! Call the solver
		call lsvecopt(evalf,evalg,quadstep,stp,stmin,stmax,m,mquad,    &
					  mnquad,quadratic,quadind,nquadind,f0,g0,ftol,    &
					  gtol,iprint,nfev,ngev,outiter,totiniter,info)
	end do

end program main
